## API

- [ Compiler and C++ Standard](compiler_and_standard_support.md) support for simple_enum
- definig enum [bounds](enum_bounds.md)
- [`limits::min and limits::max`](simple_enum_limits_documentation.md)
- [`enum_cast`](enum_cast.md) conversion from `std::string_view` to enum values
- [`enum_index`](enum_index.md) and `consteval_enum_index`
- [`enum_name`](enum_name.md) convert enumeration values to their string literals
- [`enumeration_name_v`](enumeration_name.md) compile-time name of an enumeration type
- [`enum_view`](enum_view.md) range view over an enumeration
- [`enum_names`](enum_names.md) view over all string literal values of a bounded enumeration
- [`enum_enumerations`](enum_names.md) view over all values of a bounded enumeration
- [`std::format`](std_format.md) support for enumerations
- [`fmt::format`](fmt_format.md) support for enumerations
- [`generic_error_category`](generic_error_category.md) generic template for error handling with std::expected<T,std::error_code> 
- [`expected_ec` and `make_unexpected_ec`](expected_error_code_helpers.md) expected error code helpers
- [glaze json/rpc with enum names support](glaze_json_enum_support.md)
- [examples](examples.md) example usage
- [`simple_enum` CPM installation guide](simple_enum_installation_guide.md)
- [`simple_enum` vcpkg installation guide](simple_enum_vcpkg_overlay_installation_instructions.md)

